/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package soxtest;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.List;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JFrame;

/**
 *
 * @author dienert
 */
public class Sox extends JFrame implements ActionListener {

    Runtime rt = Runtime.getRuntime();
    ProcessBuilder pb;
    Process play;
    Process pidOfPlay;
    Process kill;
    String[] pidString;
    boolean laeuftSchon = false;
    ArrayList<String> cmd;

    public void actionPerformed(ActionEvent ae) {
        String command = ae.getActionCommand();
        if (command.equals("start")) {
            try {
                System.out.println("start gedrueckt");
                if(!laeuftSchon){
                cmd = new ArrayList();
                cmd.add("/usr/bin/play");
                cmd.add("/tmp/sfhm.m4a");
                pb = new ProcessBuilder(cmd);
                play=pb.start();
                
                cmd =new ArrayList();
                cmd.add("/bin/pidof");
                cmd.add("play");
                pb = new ProcessBuilder(cmd);
                pidOfPlay = pb.start();
                BufferedReader strom =
                        new BufferedReader(
                        new InputStreamReader(
                        pidOfPlay.getInputStream()));
                pidString = strom.readLine().split(" ");
                System.out.println("pid:" + pidString[0]);
                laeuftSchon = true;
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }else if(command.equals("halt")){
            System.out.println("halt gedrueckt");
            try {
                cmd = new ArrayList();
                cmd.add("kill");
                cmd.add("-stop");
                cmd.add(pidString[0]);
                pb = new ProcessBuilder(cmd);
                kill = pb.start();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }else if(command.equals("weiter")){
            System.out.println("weiter gedrueckt");
            try {
                cmd = new ArrayList();
                cmd.add("kill");
                cmd.add("-cont");
                cmd.add(pidString[0]);
                pb = new ProcessBuilder(cmd);
                kill = pb.start();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        } else if (command.equals("stop")) {
            System.out.println("stop gedrueckt");
            try {
                play.destroy();
                laeuftSchon = false;
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
    }

    public Sox(String title) {
        this.setTitle(title);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setSize(600, 400);

        Container contentPane = this.getContentPane();
        contentPane.setLayout(new BorderLayout());

        JButton start = new JButton("start");
        start.addActionListener(this);

        JButton stop = new JButton("stop");
        stop.addActionListener(this);


        JButton halt = new JButton("halt");
        halt.addActionListener(this);

        JButton weiter = new JButton("weiter");
        weiter.addActionListener(this);

        contentPane.add(start, BorderLayout.NORTH);
        contentPane.add(stop, BorderLayout.SOUTH);
        contentPane.add(halt, BorderLayout.WEST);
        contentPane.add(weiter, BorderLayout.EAST);

        this.setVisible(true);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Sox("soxtest");
    }
}
